
#import "b4i_main.h"


@implementation b4i_main 


+ (instancetype)new {
    static b4i_main* shared = nil;
    if (shared == nil) {
        shared = [self alloc];
        shared.bi = [[B4I alloc] init:shared];
        shared.__c = [B4ICommon new];
    }
    return shared;
}

- (NSString*)  _application_background{
 //BA.debugLineNum = 60;BA.debugLine="Private Sub Application_Background";
 //BA.debugLineNum = 61;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _application_start:(B4INavigationControllerWrapper*) _nav{
[self initializeStaticModules];
 //BA.debugLineNum = 46;BA.debugLine="Private Sub Application_Start (Nav As NavigationCo";
 //BA.debugLineNum = 48;BA.debugLine="NavControl = Nav";
self._navcontrol = _nav;
 //BA.debugLineNum = 49;BA.debugLine="Page1.Initialize(\"Page1\")";
[self._page1 Initialize:self.bi :@"Page1"];
 //BA.debugLineNum = 50;BA.debugLine="Page1.Title = \"Page 1\"";
[self._page1 setTitle:@"Page 1"];
 //BA.debugLineNum = 51;BA.debugLine="Page1.RootPanel.LoadLayout(\"Layout1\")";
[[self._page1 RootPanel] LoadLayout:@"Layout1" :self.bi];
 //BA.debugLineNum = 52;BA.debugLine="Page1.RootPanel.Color = Colors.White";
[[self._page1 RootPanel] setColor:[[self.__c Colors] White]];
 //BA.debugLineNum = 53;BA.debugLine="NavControl.ShowPage(Page1)";
[self._navcontrol ShowPage:(UIViewController*)((self._page1).object)];
 //BA.debugLineNum = 55;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _button1_click{
B4INativeObject* _nativeme = nil;
 //BA.debugLineNum = 63;BA.debugLine="Sub Button1_Click";
 //BA.debugLineNum = 65;BA.debugLine="Dim NativeMe As NativeObject = Me";
_nativeme = [B4INativeObject new];
_nativeme.object = (NSObject*)(self);
 //BA.debugLineNum = 66;BA.debugLine="b= TextField1.Text";
self._b = [self._textfield1 Text];
 //BA.debugLineNum = 68;BA.debugLine="NativeMe.RunMethod(\"createQRForString::\", Array (";
[_nativeme RunMethod:@"createQRForString::" :[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:(NSObject*)(self._b)],[B4I nilToNSNull:(NSObject*)((self._imageview1).object)]]]];
 //BA.debugLineNum = 70;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _page1_resize:(int) _width :(int) _height{
 //BA.debugLineNum = 57;BA.debugLine="Private Sub Page1_Resize(Width As Int, Height As I";
 //BA.debugLineNum = 58;BA.debugLine="End Sub";
return @"";
}

- (void)initializeStaticModules {
    [[b4i_main new]initializeModule];

}
- (NSString*)  _process_globals{
 //BA.debugLineNum = 34;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 37;BA.debugLine="Public App As Application";
self._app = [B4IApplicationWrapper new];
 //BA.debugLineNum = 38;BA.debugLine="Public NavControl As NavigationController";
self._navcontrol = [B4INavigationControllerWrapper new];
 //BA.debugLineNum = 39;BA.debugLine="Private Page1 As Page";
self._page1 = [B4IPage new];
 //BA.debugLineNum = 40;BA.debugLine="Private b As String";
self._b = @"";
 //BA.debugLineNum = 41;BA.debugLine="Private ImageView1 As ImageView";
self._imageview1 = [B4IImageViewWrapper new];
 //BA.debugLineNum = 42;BA.debugLine="Private Button1 As Button";
self._button1 = [B4IButtonWrapper new];
 //BA.debugLineNum = 43;BA.debugLine="Private TextField1 As TextField";
self._textfield1 = [B4ITextFieldWrapper new];
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return @"";
}
- (void)createQRForString:(NSString *)qrString :(UIImageView *)qrImageView
{
  // Need To convert the string To a UTF-8 encoded NSData object
  NSData *stringData = [qrString dataUsingEncoding: NSISOLatin1StringEncoding];

  // Create the filter
  CIFilter *qrFilter = [CIFilter filterWithName:@"CIQRCodeGenerator"];
  // Set the message content And error-correction level
  [qrFilter setValue:stringData forKey:@"inputMessage"];
  [qrFilter setValue:@"M" forKey:@"inputCorrectionLevel"];
 
   // Remove blur effect with scaling
   CGAffineTransform transform = CGAffineTransformMakeScale(100.0f,100.0f);
   CIImage *qrOutput = [qrFilter.outputImage imageByApplyingTransform: transform];

   //Convert CIImage to UIImage
   UIImage *qrImage = [[UIImage alloc] initWithCIImage:qrOutput];
 
   //Set Image to ImageView
   [qrImageView setImage:qrImage];
}
@end
